'-- 8253tmr.bas ------------------------------------------------ >>fst'00<< -
' - Zeitmessung im Mikrosekundenbereich
'   durch Programmierung des Programmierbaren-Intervall-Timers (PIT) 8253.
' - Aufloesungen von ca. 1 Mikrosekunde theoretisch moeglich.
' - Maximale Messdauer knapp 55 Millisekunden.
' - Beispiele fr die Nutzung von Zaehler 0 und Zaehler 2.
' - Der entscheidende Code steht in Z0init / Z2init bzw. Z0lesen& / Z2lesen&
' - Public Domain
'-- V 20001218 ------------------------------ http://home.arcor.de/steini63 -

DECLARE FUNCTION AnzahlAuto& () 'Anzahl Test-Schleifen automatisch bestimmen
DECLARE SUB Test (Anzahl&)      'Test-SUB, deren Dauer gemessen wird
DECLARE SUB Z0init ()           '8253 Zhler 0 initialisieren
DECLARE SUB Z2init ()           '8253 Zhler 2 initialisieren
DECLARE FUNCTION Z0lesen& ()    '8253 Zhler 0 auslesen
DECLARE FUNCTION Z2lesen& ()    '8253 Zhler 2 auslesen

Anzahl& = AnzahlAuto&   'Schleifenanzahl der Testroutine ermitteln
'============================================================================
'Anzahl& = 5000    'Schleifenanzahl der Testroutine manuell festlegen
'Dieser Wert wird von der FUNCTION AnzahlAuto& automatisch ermittelt
'Bei Messzeiten ber 54000 Mikrosek kann der Zhler berlaufen -> MESSFEHLER!
'============================================================================

CLS
PRINT " Zeitmessung im Mikrosekundenbereich                                   st'00"
PRINT " mit dem Programmierbaren-Intervall-Timer (PIT) 8253"
PRINT " ---------------------------------------------------"
PRINT "    Bitte unter DOS oder im DOS-Modus ausfhren!"
PRINT " ---------------------------------------------------"
PRINT
PRINT " Zeitdauer fr"; Anzahl&; "Schleifen in der SUB Test"

minqs0& = 66666         'fiktive Minimalwerte; werden immer unterschritten
minqs2& = 66666

DO                      'Hauptschleife

 CALL Z0init            '8253 Zhler 0 initialisieren
 CALL Test(Anzahl&)     'Test-SUB, deren Dauer gemessen wird
 z0& = Z0lesen&         '8253 Zhler 0 auslesen

 CALL Z2init            '8253 Zhler 2 initialisieren
 CALL Test(Anzahl&)     'Test-SUB, deren Dauer gemessen wird
 z2& = Z2lesen&         '8253 Zhler 2 auslesen

 qs0& = z0& * .8380965  'Zhlerstand in Mikrosekunden umrechnen;
 qs2& = z2& * .8380965  'Zhler zhlt alle 0,8380965 Mikrosekunden

 IF qs0& < minqs0& THEN minqs0& = qs0&   'Minimalwert Z0 festhalten
 IF qs0& > maxqs0& THEN maxqs0& = qs0&   'Maximalwert Z0 festhalten
 diffqs0& = maxqs0& - minqs0&            'maximalen Ausschlag Z0 festhalten

 IF qs2& < minqs2& THEN minqs2& = qs2&   'Minimalwert Z2 festhalten
 IF qs2& > maxqs2& THEN maxqs2& = qs2&   'Maximalwert Z2 festhalten
 diffqs2& = maxqs2& - minqs2&            'maximalen Ausschlag Z2 festhalten

 LOCATE 9, 1
       PRINT "                        Zhler0  Zhler2"
       PRINT "                        -----------------"
 PRINT USING " 8253-Tics     aktuell #######  #######"; z0&; z2&
 PRINT USING " Mikrosekunden aktuell #######  #######"; qs0&; qs2&
 PRINT USING " Mikrosekunden MAX     #######  #######"; maxqs0&; maxqs2&
 PRINT USING " Mikrosekunden MIN     #######  #######"; minqs0&; minqs2&
 PRINT USING " MAX Differenz         #######  #######"; diffqs0&; diffqs2&
 PRINT USING " MAX Differenz in %     ###.##%  ###.##%"; diffqs0& / minqs0& * 100; diffqs2& / minqs2& * 100
 PRINT
 PRINT " Zeit  "; TIME$;
 PRINT USING "   Timer  #####.#  "; TIMER
 PRINT
 PRINT " Der DOS-Timer kann behindert werden, weil zeitweise der Timer-Interrupt"
 PRINT " gesperrt ist, bzw. der Zhler 0 des 8253 gendert wird."
 PRINT
 PRINT " ENDE mit [Esc]"

LOOP UNTIL INKEY$ = CHR$(27)

FUNCTION AnzahlAuto&
'die Anzahl der Schleifen fr die SUB Test wird automatisch errechnet,
'um einen gltigen Messbereich (max. 54,925 Millisekunden) unabhngig
'von der Rechnergeschwindigkeit zu erhalten.

DEF SEG = 0
Ti% = PEEK(&H46C)                  'DOS-Zhler auslesen
DO: LOOP WHILE PEEK(&H46C) = Ti%   'auf Zhlersprung warten

Ti% = PEEK(&H46C)                  'DOS-Zhler lesen
DO
 CALL Test(200)                    'Anzahl von 200'er Schleifen whrend
 Z& = Z& + 200                     'einer Timer-Periode messen
LOOP WHILE PEEK(&H46C) = Ti%

AnzahlAuto& = Z& \ 2               'wir nehmen die Hlfte

END FUNCTION

SUB Test (Anzahl&)
FOR i& = 1 TO Anzahl&
 y% = 12 * 34         'das ist die zu messende Anweisung
NEXT
END SUB

SUB Z0init
OUT (&H43), 52        '8253 Zhler 0 auf Modus 2 setzen (Normalmodus)
OUT (&H40), 255       'Startwert LowByte setzen
OUT (&H40), 255       'Startwert HighByte setzen
END SUB

FUNCTION Z0lesen&
OUT (&H43), 0         'Werte 8253-intern speichern (Counter Latch)
a& = INP(&H40)        'LowByte lesen
b& = INP(&H40)        'HighByte lesen
t& = a& + b& * 256    'Bytes nach Wertigkeit summieren
Z0lesen& = 65535 - t& 'Differenz errechnen (Zhler zhlt abwrts !)
END FUNCTION

SUB Z2init
OUT (&H61), INP(&H61) OR 1  'Lautsprecher und damit Zhler 2 aktivieren
OUT (&H21), 255             'alle Interrupts maskieren
OUT (&H43), 176             '10110000bin  8253 Zhler 2 auf Modus 0 setzen
OUT (&H42), 255             'Startwert LowByte setzen
OUT (&H42), 255             'Startwert HighByte setzen
END SUB

FUNCTION Z2lesen&
OUT (&H43), 128       'Werte 8253-intern speichern (Counter Latch)
a& = INP(&H42)        'LowByte lesen
b& = INP(&H42)        'HighByte lesen
OUT (&H21), 0         'Interrupts wieder zulassen
t& = a& + b& * 256    'Bytes nach Wertigkeit summieren
Z2lesen& = 65535 - t& 'Differenz errechnen (Zhler zhlt abwrts !)
END FUNCTION

