DECLARE FUNCTION RTCDate$ ()
DECLARE FUNCTION RTCTime$ ()
'-- rtc2tmr.bas ------------------------------------------------ >>fst'01<< -
' - Demo, wie manipulierte DOS-Timerwerte mit der CMOS Echtzeituhr
'   (Real-Time-Clock 'RTC') berichtigt werden koennen.
' - hilfreich, nach Manipulationen an den Timerwerten im Speicher,
'   am PIT 8253/8354 usw.
' - PUBLIC DOMAIN
'-- V 20010923 ------------------------------ http://home.arcor.de/steini63 -

CLS
PRINT
PRINT " Auslesen der CMOS-Echtzeituhr (RTC)                                 >>fst'01<<"
PRINT " und korrigieren des Systemtimers mittels der RTC."
PRINT " MANIPULATION DES SYSTEMTIMERS"
PRINT " FUNKTIONIERT NUR UNTER PUREM DOS !"

DO WHILE INKEY$ = ""
 LOCATE 7
 PRINT " Systemzeit                 :  "; DATE$; "  "; TIME$
 PRINT " CMOS Echtzeit-Uhr (RTC)    :  "; RTCDate$; "  "; RTCTime$
 PRINT
 PRINT " TASTE ..."
LOOP

'-- Plausibilaetskontrolle fuer die RTC-Werte
'   (Abbruch, wenn kein RTC vorhanden z.B bei PC, XT, Palmtops)
Dat$ = RTCDate$
Zeit$ = RTCTime$
Jahr% = VAL(RIGHT$(Dat$, 4))
Monat% = VAL(LEFT$(Dat$, 2))
Std% = VAL(LEFT$(Zeit$, 2))
IF Jahr% < 1900 OR Jahr% > 2999 THEN Fehler% = -1
IF Monat% < 1 OR Monat% > 12 THEN Fehler% = -1
IF Std% < 0 OR Std% > 24 THEN Fehler% = -1
IF Fehler% THEN BEEP: PRINT " *** Werte der Echtzeituhr ungueltig *** ": END

'--- DOS-Timer verstellen (auf ca. 4 Sek vor Mitternacht)
DEF SEG = 0
POKE &H46C, 100: POKE &H46D, 0: POKE &H46E, 24
DEF SEG

DO WHILE INKEY$ = ""
 LOCATE 10
 PRINT " Systemzeit (manipuliert)   :  "; DATE$; "  "; TIME$
 PRINT " CMOS Echtzeit-Uhr (RTC)    :  "; RTCDate$; "  "; RTCTime$
 PRINT
 PRINT " TASTE ..."
LOOP
PRINT

'--- DOS-Timer mit Werten der Echtzeituhr korrigieren
'ACHTUNG: Die Anweisung TIME$ aendert das Systemdatum anhand der RTC;
'         die Anweisung DATE$ aendert die Systemzeit anhand der RTC !
DO: LOOP WHILE RTCTime$ = "23:59:59"  'Tageswechsel abwarten
Zeit$ = RTCTime$  'Zeit sichern, bevor sie von DATE$ ueberschrieben wird
DATE$ = RTCDate$  'Systemdatum anhand RTC aktualisieren
TIME$ = Zeit$     'Systemzeit anhand gesicherter RTC-Zeit aktualisieren

DO WHILE INKEY$ = ""
 LOCATE 13
 PRINT " Systemzeit (korrigiert)    :  "; DATE$; "  "; TIME$
 PRINT " CMOS Echtzeit-Uhr (RTC)    :  "; RTCDate$; "  "; RTCTime$
 PRINT
 PRINT " TASTE ..."
LOOP

LOCATE 16: PRINT " E N D E  "
PRINT

END

FUNCTION RTCDate$
'speichert das Datum der RTC in einem String (Format identisch zu DATE$)

FOR i% = 1 TO 4
 IF i% = 1 THEN SB% = 8            'SteuerByte  8=Monat
 IF i% = 2 THEN SB% = 7            'SteuerByte  7=Tag
 IF i% = 3 THEN SB% = 50           'SteuerByte 50=Jahrhundert
 IF i% = 4 THEN SB% = 9            'SteuerByte  9=Jahrzehnt
 DO: OUT &H70, 10                  'Statusregister A abfragen, wenn Bit 7
 LOOP WHILE INP(&H71) > 127        ' gesetzt, wird gerade aktualisiert
 OUT &H70, SB%                     'SteuerByte ins CMOS-Steuerregister
 in% = INP(&H71)                   'Wert lesen
 in$ = HEX$(in%)                   'BCD-Format wandeln; dezimal->hex->String
 IF LEN(in$) = 1 THEN in$ = "0" + in$   'fuehrende Null ergaenzen
 Dat$ = Dat$ + in$                 'String zusammenbauen
 IF i% < 3 THEN Dat$ = Dat$ + "-"  'Trennzeichen ergaenzen
NEXT

RTCDate$ = Dat$

END FUNCTION

FUNCTION RTCTime$
'speichert die Zeit der RTC in einem String (Format identisch zu TIME$)

FOR SB% = 4 TO 0 STEP -2          'SteuerByte 4=Stunde, 2=Minute, 0=Sekunde
 DO: OUT &H70, 10                 'Statusregister A abfragen, wenn Bit 7
 LOOP WHILE INP(&H71) > 127       ' gesetzt, wird gerade aktualisiert
 OUT &H70, SB%                    'SteuerByte ins CMOS-Steuerregister
 in% = INP(&H71)                  'Wert lesen
 in$ = HEX$(in%)                  'BCD-Format wandeln; dezimal->hex->String
 IF LEN(in$) = 1 THEN in$ = "0" + in$   'fuehrende Null ergaenzen
 Zeit$ = Zeit$ + in$              'String zusammenbauen
 IF SB% THEN Zeit$ = Zeit$ + ":"  'Trennzeichen ergaenzen
NEXT

RTCTime$ = Zeit$

END FUNCTION

